<?php

// Function to send the request to the shortening API
function pus_shortcode_shorten_url($url) {

	$body = ['url'  => $url,];
	$body = json_encode( $body );
	$args = array(
		'body' 		=> $body,
		'method'      => 'POST',
		'timeout'     => 10,
		'redirection' => 5,
		'httpversion' => '1.0',
		
    	'headers' 	=> array(
        	'Authorization' => 'Bearer ' . get_option('pus_api_key'),
			'Content-Type'  => 'application/json'
    )
);
	$response = wp_remote_post('https://ice.bio/api/url/add', $args );
	$body = wp_remote_retrieve_body($response);
	

	if (is_wp_error($response)) {
	$error_message = $response->get_error_message();
	return "Something went wrong: $error_message";
	}
	
    if ($object = json_decode($body)) {
        if (isset($object->shorturl)) {
            return $object->shorturl;
        }
    }

    return $body;
}

// Function to modify external links in content
function pus_modify_external_links($content) {
    // Check if auto shortening feature is turned on
    $auto_shorten = get_option('pus_auto_shorten_external_links', false);

    if ($auto_shorten && !is_admin()) {
        $save_shortened_links = get_option('pus_save_shortened_links', false);

        $dom = new DOMDocument();
        @$dom->loadHTML($content, LIBXML_HTML_NOIMPLIED | LIBXML_HTML_NODEFDTD);
        $links = $dom->getElementsByTagName('a');

        foreach ($links as $link) {
            $href = $link->getAttribute('href');

            // Ignore non-HTTP/HTTPS links
            if (stripos($href, 'http') !== 0) {
                continue;
            }

            // Ignore links to the current site
            if (stripos($href, site_url()) === 0) {
                continue;
            }

            $short_url = pus_shortcode_shorten_url($href);

            if ($save_shortened_links) {
                update_post_meta(get_the_ID(), 'pus_shortened_links', [$href => $short_url]);
            }

            $link->setAttribute('href', $short_url);
        }

        $new_content = $dom->saveHTML();
        //$new_content = substr($new_content, strpos($new_content, '<body>') + 6, -16);

        return $new_content;
    }

    return $content;
}

// Register the shortcode
add_shortcode(esc_attr(get_option('pus_custom_shortcode')), function($atts, $content = null) {
    if ($content !== null) {
        return pus_shortcode_shorten_url($content);
    }
});