<?php
// Add an options page for the plugin
add_action('admin_menu', 'pus_add_plugin_page');
function pus_add_plugin_page()
{
    add_options_page(
        'Link Shortener Settings',
        'Link Shortener',
        'manage_options',
        'pus-plugin-settings',
        'pus_render_plugin_settings_page'
    );
}

// Register the plugin settings
add_action('admin_init', 'pus_register_plugin_settings');
function pus_register_plugin_settings()
{
    register_setting('pus-plugin-settings-group', 'pus_api_key');
    register_setting('pus-plugin-settings-group', 'pus_auto_shorten_external_links');
    register_setting('pus-plugin-settings-group', 'pus_custom_shortcode', 'shorturl');
}

// Render the options page
function pus_render_plugin_settings_page()
{
    ?>
    <div class="wrap">
        <h1>Link Shortener Settings</h1>

        <form method="post" action="options.php">
            <?php settings_fields('pus-plugin-settings-group'); ?>
            <?php do_settings_sections('pus-plugin-settings-group'); ?>
            <table class="form-table" role="presentation">
				<tbody>
                <tr valign="top">
                    <th scope="row"><label for="pus_api_key">API Key</label></th>
                    <td><input type="text" name="pus_api_key" id="pus_api_key" value="<?php echo esc_attr(get_option('pus_api_key')); ?>" />
					<p class="description" id="pus_api_key">
		Find your API Key in <a href="https://ice.bio/user/settings">https://ice.bio/user/settings</a>.</p></td>
                </tr>
					<tr valign="top">
                    <th scope="row"><label for="pus_custom_shortcode">Custom Shortcode</label></th>
                    <td><input type="text" name="pus_custom_shortcode" id="pus_custom_shortcode" value="<?php echo esc_attr(get_option('pus_custom_shortcode')); ?>" />
					<p class="description" id="pus_custom_shortcode">
		Use a custom Shortcode like <b>[shorturl]</b>https://example.com/long-url<b>[/shorturl]</b> .</p></td>
                </tr>
                <tr valign="top">
                    <th scope="row"><label for="pus_auto_shorten_external_links">Auto Shorten External Links</label></th>
                    <td><input type="checkbox" name="pus_auto_shorten_external_links" id="pus_auto_shorten_external_links" <?php checked((bool) get_option('pus_auto_shorten_external_links', false)); ?> /></td>
                </tr>
                </tbody>
            </table>

            <?php submit_button(); ?>
        </form>
    </div>
    <?php
}
?>